#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

typedef long	(__stdcall *AdultPdfCreate)(char *);
typedef long	(__stdcall *AdultPdfOpen)(char *);
typedef void	(__stdcall *AdultPdfClose)(long);
typedef long	(__stdcall *AdultPdfAddInfo)(long,char*,char*,char*,char*,char*);
typedef long	(__stdcall *AdultPdfSetFunction)(long,long func_code,long parameter1,long parameter2,char *para3,char *para4);
typedef long	(__stdcall *AdultPdfGetFunction)(long,long func_code,long parameter1,long parameter2,char *para3,char *para4);

typedef long	(__stdcall *AdultPdfAddImage)(long,char *);
typedef long	(__stdcall *AdultPdfAddImageData)(long,char *,long ,long ,long );

typedef long	(__stdcall *AdultPdfAddTextEx)(long,long,long,char *,long );

typedef long	(__stdcall *AdultPdfAddLine)  (long id,long sx,long sy,long ex,long ey,
										   long side_width,long side_color);
typedef long	(__stdcall *AdultPdfAddRect  )(long id,long sx,long sy,long ex,long ey,
										   long side_width,long side_color,
										   long flagFill,long fill_color);


HMODULE				g_hAdultPdfW=NULL;

AdultPdfCreate			pAdultPdfCreate;
AdultPdfOpen			pAdultPdfOpen;
AdultPdfAddImage		pAdultPdfAddImage;
AdultPdfAddImageData	pAdultPdfAddImageData;
AdultPdfClose			pAdultPdfClose	;	
AdultPdfAddInfo			pAdultPdfAddInfo;	
AdultPdfSetFunction		pAdultPdfSetFunction;
AdultPdfGetFunction		pAdultPdfGetFunction;
AdultPdfAddTextEx		pAdultPdfAddTextEx;
AdultPdfAddLine			pAdultPdfAddLine;
AdultPdfAddRect			pAdultPdfAddRect;

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadAdultPdfWDll(void);
void	FreeAdultPdfWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadAdultPdfWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"ImageToPDF.dll");
	g_hAdultPdfW=LoadLibrary(path);
	if(g_hAdultPdfW==NULL)
		goto Failer;

	pAdultPdfOpen=(AdultPdfOpen)GetProcAddress(g_hAdultPdfW,"AdultPdfOpen");
	if(pAdultPdfOpen==NULL)
		goto Failer;
	pAdultPdfCreate=(AdultPdfCreate)GetProcAddress(g_hAdultPdfW,"AdultPdfCreate");
	if(pAdultPdfCreate==NULL)
		goto Failer;
	pAdultPdfAddImage=(AdultPdfAddImage)GetProcAddress(g_hAdultPdfW,"AdultPdfAddImage");
	if(pAdultPdfAddImage==NULL)
		goto Failer;
	pAdultPdfAddImageData=(AdultPdfAddImageData)GetProcAddress(g_hAdultPdfW,"AdultPdfAddImageData");
	if(pAdultPdfAddImageData==NULL)
		goto Failer;
	pAdultPdfClose=(AdultPdfClose)GetProcAddress(g_hAdultPdfW,"AdultPdfClose");
	if(pAdultPdfClose==NULL)
		goto Failer;
	pAdultPdfAddInfo=(AdultPdfAddInfo)GetProcAddress(g_hAdultPdfW,"AdultPdfAddInfo");
	if(pAdultPdfAddInfo==NULL)
		goto Failer;
	pAdultPdfSetFunction=(AdultPdfSetFunction)GetProcAddress(g_hAdultPdfW,"AdultPdfSetFunction");
	if(pAdultPdfSetFunction==NULL)
		goto Failer;
	pAdultPdfGetFunction=(AdultPdfGetFunction)GetProcAddress(g_hAdultPdfW,"AdultPdfGetFunction");
	if(pAdultPdfGetFunction==NULL)
		goto Failer;
	pAdultPdfAddTextEx=(AdultPdfAddTextEx)GetProcAddress(g_hAdultPdfW,"AdultPdfAddTextEx");
	if(pAdultPdfAddTextEx==NULL)
		goto Failer;
	pAdultPdfAddLine=(AdultPdfAddLine)GetProcAddress(g_hAdultPdfW,"AdultPdfAddLine");
	if(pAdultPdfAddLine==NULL)
		goto Failer;
	pAdultPdfAddRect=(AdultPdfAddRect)GetProcAddress(g_hAdultPdfW,"AdultPdfAddRect");
	if(pAdultPdfAddRect==NULL)
		goto Failer;
	return TRUE;
Failer:
	FreeAdultPdfWDll(); 
	return FALSE;

}

void FreeAdultPdfWDll()
{
	if(g_hAdultPdfW==NULL)
		return ;
	FreeLibrary(g_hAdultPdfW);
	g_hAdultPdfW=NULL;
}




void main()
{
	char szPDFFile[256];
	char szImageFile[256];
	long id;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	if(!LoadAdultPdfWDll())
		return ;

	GetModulePath(szPDFFile,"append.pdf");
	id=pAdultPdfOpen(szPDFFile);
	if(id>0){

		pAdultPdfAddImage(id,"test1.jpg");
		pAdultPdfAddImage(id,"test1.jpg");

		pAdultPdfClose(id);
	}
	FreeAdultPdfWDll();

}